summaryrefslogtreecommitdiffstats
path: root/libraries/libprelude
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/libprelude')
-rw-r--r--libraries/libprelude/README25
-rw-r--r--libraries/libprelude/doinst.sh17
-rw-r--r--libraries/libprelude/libprelude.SlackBuild127
-rw-r--r--libraries/libprelude/libprelude.info10
-rw-r--r--libraries/libprelude/slack-desc19
5 files changed, 198 insertions, 0 deletions
diff --git a/libraries/libprelude/README b/libraries/libprelude/README
new file mode 100644
index 0000000000..8c948f080b
--- /dev/null
+++ b/libraries/libprelude/README
@@ -0,0 +1,25 @@
+Prelude Library (https://www.prelude-siem.org)
+
+Prelude Library Overview
+========================
+
+The Prelude Library is used to make sensor developers' life better by
+providing features used by every sensor:
+
+ - Manager(s) Connection management (with fallback in case all
+ configured Managers are down, and automatic reconnection).
+
+ - Interface to communicate with the Prelude Manager.
+
+ - Asynchronous Message interface (allowing sensor to emit message
+ without blocking, even if there is latency on the wire).
+
+ - Asynchronous timer interface.
+
+ - Generic configuration API, providing a generic abstraction for
+ command-line, configuration file option, and wide option support.
+
+ - Wide option managment allowing sensor-exported options to be
+ directly accessible from the Manager administrative console.
+
+ - Generic plugin API.
diff --git a/libraries/libprelude/doinst.sh b/libraries/libprelude/doinst.sh
new file mode 100644
index 0000000000..0ca862d4db
--- /dev/null
+++ b/libraries/libprelude/doinst.sh
@@ -0,0 +1,17 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+config etc/prelude/default/client.conf.new
+config etc/prelude/default/global.conf.new
+config etc/prelude/default/idmef-client.conf.new
+config etc/prelude/default/tls.conf.new
diff --git a/libraries/libprelude/libprelude.SlackBuild b/libraries/libprelude/libprelude.SlackBuild
new file mode 100644
index 0000000000..c509f3255f
--- /dev/null
+++ b/libraries/libprelude/libprelude.SlackBuild
@@ -0,0 +1,127 @@
+#!/bin/bash
+
+# Slackware build script for libprelude
+
+# Copyright 2021 pyllyukko
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# 20220420 bkw: Modified by SlackBuilds.org, BUILD=3:
+# - strip perl and pythons shared libs.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=libprelude
+VERSION=${VERSION:-5.2.0}
+BUILD=${BUILD:-3}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \+
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --disable-static \
+ --with-python3 \
+ --without-ruby \
+ --with-perl-installdirs=vendor \
+ --build=$ARCH-slackware-linux
+
+make
+make install-strip DESTDIR=$PKG
+gzip -9 $PKG/usr/man/man*/*
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+for i in client global idmef-client tls
+do
+ mv -v ${PKG}/etc/prelude/default/${i}.conf ${PKG}/etc/prelude/default/${i}.conf.new
+done
+
+find $PKG -name perllocal.pod \
+ -o -name ".packlist" \
+ -o -name "*.bs" \
+ | xargs rm -f
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ COPYING AUTHORS LICENSE.README HACKING.README README NEWS \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+rm -f $PKG/usr/lib*/*.la
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/libprelude/libprelude.info b/libraries/libprelude/libprelude.info
new file mode 100644
index 0000000000..c32f7f2ebb
--- /dev/null
+++ b/libraries/libprelude/libprelude.info
@@ -0,0 +1,10 @@
+PRGNAM="libprelude"
+VERSION="5.2.0"
+HOMEPAGE="https://www.prelude-siem.org"
+DOWNLOAD="https://www.prelude-siem.org/attachments/download/1395/libprelude-5.2.0.tar.gz"
+MD5SUM="4db429af160450dc37c7ade001abf8c4"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="pyllyukko"
+EMAIL="pyllyukko@maimed.org"
diff --git a/libraries/libprelude/slack-desc b/libraries/libprelude/slack-desc
new file mode 100644
index 0000000000..34c2ee4640
--- /dev/null
+++ b/libraries/libprelude/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+libprelude: libprelude (Prelude SIEM/sensor library)
+libprelude:
+libprelude: The Prelude Library is used to make sensor developers' life better by
+libprelude: providing features used by every sensor:
+libprelude: Manager(s) connection management, interface to communicate with
+libprelude: the Prelude Manager, asynchronous message interface, asynchronous
+libprelude: timer interface, generic configuration API, wide option managment
+libprelude: and generic plugin API.
+libprelude:
+libprelude: Homepage: https://www.prelude-siem.org
+libprelude: